#include "_Uart.h"
#include <stdarg.h>

extern void HaltFunc();

#define W_REG(reg, data) (*reg) = (data)
#define R_REG(reg) (*reg)


/*
 * UART Initialization
 */
void _Uart_Init(U32 u32Pclk, U32 u32baud, U32 u32WhichTxUART)
{
	U32 u32Offset = UOFFSET * (u32WhichTxUART);
	U32 u32Div = 0;
	
    /*
        FIFO control register, FIFO disable
    */
    
    

    /*
        MODEM control register, AFC disable
    */


    /*
        Line control register : Normal,No parity,1 stop,8 bits
    */


    /*
        Uart Control register
    */
	*(UCON0 + u32Offset) = (UCON_CLK_PCLK | UCON_TXINT_LEVEL | UCON_RXERR_ENABLE | UCON_TXMODE_INT | UCON_RXMODE_INT);

	switch (u32baud)
	{
		case 115200:
			switch (u32Pclk)
			{
				case 50000000:
/*					u32Div = ?; */
					break;
				default:
					while(1);
			}
			break;
		default:
			HaltFunc ();		
			while (1);
	}

    /*
        Baud rate divisior register
    */


	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	__asm("nop");
	
	
}

/*
 * ==============================================================================================================
 */

void _Uart_SendChar(U32 u32WhichTxUART, char cChar)
{
	U32 u32Offset = UOFFSET * (u32WhichTxUART);
	switch((*(UFCON0 + u32Offset)) & UFCON_FIFO)
	{
		case UFCON_FIFO_ENABLE:
/* Check if can send */
			break;
		case UFCON_FIFO_DISABLE:
/* Check if can send */
			break;
		default:
			break;

	}
	
/* Write actual byte */

}

/*
 * ==============================================================================================================
 */
void _Uart_SendString(U32 u32WhichTxUART, char *sString)
{
	while(*sString)
	{
		_Uart_SendChar(u32WhichTxUART, *(sString++));
	}
}



/*
 * ==============================================================================================================
 */
char _Uart_Getch(unsigned long u32WhichUart)
{
	U32 u32Offset = UOFFSET * (u32WhichUart);
	switch((*(UFCON0 + u32Offset)) & UFCON_FIFO)
	{
		case UFCON_FIFO_ENABLE:
/* Check if data available */		
			break;
		case UFCON_FIFO_DISABLE:
/* Check if data available */		
			break;
		default:
			break;
	}
	
/* Return actual data */	
	return (char)(*(URXH0 + u32Offset));
}


